#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct Compare {
	bool operator()(pair<int, int> left, pair<int, int> right) {
		return left.second < right.second;
	}
};

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T; cin >> T;
	while(T--) {
		// Parameters
		// - s: Environment size
		// - k: Total power
		int s, k;
		cin >> s >> k;

		// Usage: dp[ power remaining ][ location mod power ]
		// Represents leftmost/rightmost position that Gleb can be at given his current power, 
		// his position mod his power, and that Gleb must have moved using his current power
		int latest[k+1][k];
		int earliest[k+1][k];
		rep(power, 0, k+1) rep(mod, 0, k) {
			latest[power][mod] = -1;
			earliest[power][mod] = -1;
		}

		// Base case: Power <= 1. Gleb can be anywhere. Edge cases don't really matter
		latest[1][0] = s;
		earliest[1][0] = 0;

		// Base case: Power = k. Gleb can only be at multiples of k
		latest[k][0] = (s / k) * k;
		earliest[k][0] = k;

		for(int power = k-1; power > 1; --power) {
			// Extract starting positions
			queue<pair<int, int>> pq;
			for(int start = 0; start < power + 1; ++start) {
				int prop = latest[power+1][start];
				if(prop != -1) pq.push({earliest[power+1][start], prop});
			}

			while(!pq.empty()) {
				// Start from proposed leftmost position
				pair<int, int> poll = pq.front();
				pq.pop();
				int left = s - poll.second;
				int right = s - poll.first;

				// Move as little as possible
				for(int rep = 0; rep < power; ++rep) {
					int start = left + (rep * (power+1));
					if(start > right) break;

					int dest = start + power;
					int prop = earliest[power][dest % power];
					if(prop == -1 || prop > dest) {
						earliest[power][dest % power] = dest;
					}
				}
			}

			// Move all the way to the left
			for(int mod = 0; mod < power; ++mod) {
				int start = earliest[power][mod];
				if(start != -1) latest[power][mod] = (s - start) / power * power + start;
			}
		}

		// Extract solution. Highest power that reaches goal
		for(int power = k; power > 0; power -= 2)
			if(latest[power][s % power] == s) {
				cout << power << '\n';
				break;
			} else if(power == 2) cout << 1 << '\n';
	}
}
